/*
  CPP_LANG=C+OPENMP+MPI
  CPP_NUM_CORES = 32
  CPP_PROCESSES_PER_NODE 8
  CPP_PROBLEM=C
 */

/* RECORD
Héctor Mayor Jiménez
student of Metodology of Parallel Programming,
at the University of Murcia, Spain
January 25, 2013
time 237
speed-up 77.83
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <assert.h>

#include <mpi.h>


#define MAX_CUBETAS         1000         //numero maximo de procesadores



int cubetas;

void ordenar(int t,int *a)
{
  int i,j,temp;

 
          for(i=0;i<t;i++)
          {
            for(j=i+1;j<t;j++)
            {
              if(a[i]>a[j])
              {
                temp=a[i];
                a[i]=a[j];
                a[j]=temp;
              }
            }
          }
       
}


void ordenarCubeta(int *laCubeta, int numElementos, int indDst, int *datos) {
  int i, j, k, elemento;

  for (i=0; i<numElementos; i++) {
    k = i;
    elemento = laCubeta[i];
    for (j=i+1; j<numElementos; j++)
        if (laCubeta[j] < elemento) {
	  k = j;
	  elemento = laCubeta[j];
        }
    laCubeta[k]  = laCubeta[i];
    datos[indDst++] = elemento;
  }
}


void ordenarT()
{
   int elemCubeta;
  int  *cubeta;
  int ncubeta;
 int *datos;
  MPI_Status status;
  
  int min;
  int max;
  
 int array[3];
      
      
      
      MPI_Recv(array,3, MPI_INT, 0,0, MPI_COMM_WORLD, &status); //recibe informacion de la cubeta
      
      min=array[0];
      max=array[1];
      elemCubeta=array[2];
      
      cubeta= (int *) calloc(sizeof(int),elemCubeta);  
      datos= (int *) calloc(sizeof(int),elemCubeta);        //cubeta ordenada
      
      
      MPI_Recv(cubeta,elemCubeta, MPI_INT,0,0, MPI_COMM_WORLD, &status);//recibimos elementos de la cubeta
    
    
    
  
     int *cubetas[MAX_CUBETAS];
   int elemCubetas[MAX_CUBETAS];
    int desplazamiento[MAX_CUBETAS];
     int i, j, k, numCubetas, enterosCubeta;
    
    numCubetas=elemCubeta/500;
    if(numCubetas<1)
    numCubetas=1;
    
    if(numCubetas>MAX_CUBETAS)
    numCubetas=MAX_CUBETAS;
    
  
    
    enterosCubeta = (max-min+numCubetas) / numCubetas;
    
     for (i=0; i<numCubetas; i++)
    cubetas[i] = (int *) calloc(sizeof(int),elemCubeta);
 
     for (i=0; i<numCubetas; i++) elemCubetas[i] = 0;     
   
     
     for (i=0; i<elemCubeta; i++) {   //Asignar datos a subcubetas
    j = (cubeta[i]-min) /enterosCubeta ;
    k = elemCubetas[j]++;    
    cubetas[j][k] = cubeta[i];
  }
 
 
  
   j = 0;
  for (i=0; i<numCubetas; i++) {
    desplazamiento[i]=j;
    j = j+elemCubetas[i];
  }
  
   
  for (i=0; i<numCubetas; i++) { //Ordenar subcubetas
    ordenarCubeta (cubetas[i], elemCubetas[i],desplazamiento[i],datos);   
  } 
      MPI_Send(datos, elemCubeta,MPI_INT, 0, 0,MPI_COMM_WORLD);  //enviar cubeta
      
   
}

void servircubetas(int t,int np,int *datos){ //igual que el principio de openmp


   int i, j, k, numCubetas,  enterosCubeta;
  int *cubetas[MAX_CUBETAS];
  int desplazamiento[MAX_CUBETAS];
  int elemCubeta[MAX_CUBETAS];

  int cs=0;  //cubetas servidas
  int cr=0; //cubetas recibidas

  
  numCubetas=np-1;

  
  
  enterosCubeta = (t+numCubetas) / numCubetas;
  for (i=0; i<numCubetas; i++)
    cubetas[i] = (int *) calloc(sizeof(int),t);

 
  for (i=0; i<numCubetas; i++) elemCubeta[i] = 0;
  
 
  for (i=0; i<t; i++) {  
    j = datos[i] / enterosCubeta;   
    k = elemCubeta[j]++;     
    cubetas[j][k] = datos[i];    
  }


  j = 0;
  for (i=0; i<numCubetas; i++) {
    desplazamiento[i]=j;
    j = j+elemCubeta[i];
  }
  
           
            MPI_Status status;            
            
            int l;
            for(l =0; l< numCubetas;l++){
                
                
                int array[3];
            array[0]= l *enterosCubeta;             //min
            array[1]= (l+1)*enterosCubeta;          //max
            array[2]= elemCubeta[l];                //elementos de la cubeta
            
                MPI_Send(array, 3,MPI_INT, l+1, 0,MPI_COMM_WORLD); 
                 MPI_Send(cubetas[l], elemCubeta[l],MPI_INT, l+1, 0,MPI_COMM_WORLD);                
            }                    
               
                                                  
            for(l =0; l< numCubetas;l++){ //recibir cubetas
                 MPI_Recv(&datos[desplazamiento[l]],elemCubeta[l], MPI_INT, l+1,0, MPI_COMM_WORLD, &status);           
                   
            }       
}    

void posicion(int t,int *a,int numpos,int *posiciones,int *datos,int nodo,int np)
{   
  
      
      if(nodo==0)
      servircubetas(t,np,a);
      else
      ordenarT();
    
    
    if(nodo==0){
          ordenar(numpos,posiciones);
          
          int i;
          for(i=0;i<numpos;i++){
              datos[i]=a[posiciones[i]];
          }   
  }  
}  
